## Goal of PR

Please describe exactly what the goal of your PR is (and link to any relevant issues)

## Implementation

Describe how that goal was achieved through the submitted implementation.

## Manual Testing

Describe how the new functionality can be tested manually.

## Automated Testing

Describe the automated testing you included which covers any and all new functionality.

## Submission Checklist

- [ ] Based on correct branch: feature submissions should be on `develop`, hotfixes should be on `master`

- [ ] The code passes our eslint definitions, unit tests, and
      contains correct TypeFlow annotations.

- [ ] Submission contains tests that cover any and all new functionality or code changes.

- [ ] Submission documents any new features or endpoints, and describes how developers
      would be expected to interact with them.

- [ ] Author has agreed to our contributor's agreement.
